import os
import json

_info_file_path = '/home/pi/AlphaI/robot_info.json'


def get_robot_info(name, default=None):
    if os.path.isfile(_info_file_path):
        # if the file exist we try to read it
        with open(_info_file_path, 'r') as robot_info:
            try:
                data = json.load(robot_info)
            except ValueError:
                # if unreadable, we create a void data,
                # it will be overwritten later
                data = dict()
        # if the left_right_bias is in the data we update
        return data.get(name, default)
    else:
        return default


def update_robot_info(name, value):
    if os.path.isfile(_info_file_path):
        # if the file exist we try to read it
        with open(_info_file_path, 'r') as robot_info:
            try:
                data = json.load(robot_info)
            except ValueError:
                # if unreadable, we create a void data,
                # it will be overwritten later
                data = {}
        # if the left_right_bias is in the data we update
        data[name] = value
    else:
        # if the file does not exist we create a data with our bias
        data = {name: value}

    # in any case, we overwrite the file or create a new one with the data
    with open(_info_file_path, 'w') as robot_info:
        json.dump(data, robot_info)

