memory_action = -1


def reward(state):
    global memory_action

    # Check whether camera center is on track
    w = 16
    h = 12
    image = state['in_v_1/2_' + str(w) + 'x' + str(h)]
    roi_side = 2
    half_side = roi_side // 2
    roi = image[h // 2 - half_side:h // 2 + half_side,
          w // 2 - half_side:w // 2 + half_side]
    roi_value = roi.mean()
    # print('roi value', roi_value)
    track_threshold = 0.5
    roi_on_track = roi_value < track_threshold
    if not roi_on_track:
        memory_action = -1
        return 0

    # Compare last action and previous last action
    # (for each action, set "direction" as follow: East = 0, NE = 1, N = 2, ...
    # SE = 7)
    directions = [4, 0, 2, 6, 3, 1, 5, 7]
    previous_last_action = memory_action
    last_action = state['last_action']
    memory_action = last_action
    if previous_last_action == -1:
        # roi was not on track the last time -> give medium reward
        return 0.4
    # direction change : get a value between 0 and 7, then between -3 and 4,
    # then between 0 and 4
    direction_change = (directions[last_action]
                        - directions[previous_last_action]) % 8
    direction_change = (direction_change + 3) % 8 - 3
    direction_change = abs(direction_change)
    if direction_change <= 1:
        # minimal change in direction -> maximal reward
        return 1
    elif direction_change == 2:
        # 90 degrees turn -> small reward
        return 0.2
    else:
        # going backward -> negative reward
        return -1
